//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ReShade effect file
// visit facebook.com/MartyMcModding for news/updates
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// MasterEffect ReBorn 1.1.205 public beta by Marty McFly
// April's edition - do not take seriously :)
// Continuation of MasterEffect 1.6.1
// Copyright  2008-2015 Marty McFly
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*==============================================================================*\
|                                GLOBAL PARAMETERS                               |
\*==============================================================================*/

#define MASTEREFFECT_TOGGLEKEY	0x2E	//[depending on keyboard layout] Key used to toggle all MasterEffect effects. See ReShade documentation for more info. 

#define USE_DEPTHBUFFER_OUTPUT	0	//[0 or 1] Depth Buffer Output: Shows you the pixel depth, this is for debugging or depth map creation only.
#define USE_SPLITSCREEN		0	//[0 or 1] Splitscreen: Disables all effects on the right half of the screen to show changes.
#define USE_HDR_LEVEL		0	//[0 to 2] HDR Level: Rendering bitrate. 0: RGBA8 | 1: RGBA16F | 2: RGBA32F
#define ME_START_ENABLED    	1 	//[0 or 1] Start with the effects enabled or disabled?
/*==============================================================================*\
|                                 ENABLE EFFECTS                                 |
\*==============================================================================*/

//COLOR
#define USE_LEVELS        	1 	//[0 or 1] Levels : Sets a new black and white point. This increases contrast but causes clipping. Use Curves instead if you want to avoid that.
#define USE_DPX           	1	//[0 or 1] Cineon DPX : Should make the image look like it's been converted to DXP Cineon - basically it's another movie-like look similar to technicolor.
#define USE_LIFTGAMMAGAIN 	1	//[0 or 1] Lift Gamma Gain : Adjust brightness and color of shadows, midtones and highlights.
#define USE_TONEMAP       	1 	//[0 or 1] Tonemap : Adjust gamma, exposure, saturation, bleach and defog. (may cause clipping).
#define USE_VIBRANCE      	1 	//[0 or 1] Vibrance : Intelligently saturates (or desaturates if you use negative values) the pixels depending on their original saturation.
#define USE_CURVES        	1 	//[0 or 1] Curves : Contrast adjustments using S-curves.

//LIGHTING
#define USE_BLOOM 		0	//[0 or 1] Bloom: Makes bright lights bleed their light into their surroundings. NOT the SweetFX way to do bloom but a more proper way.

//IMAGE ENHANCEMENTS
#define USE_SHARPENING		1	//[0 or 1] Sharpen: Sharps the image but may increase aliasing
#define USE_SMAA		1	//[0 or 1] SMAA Anti-aliasing : Smoothens jagged lines using the SMAA technique.

/*==============================================================================*\
|                             EFFECT PARAMETERS - COLOR                          |
\*==============================================================================*/

//LEVELS
#define Levels_black_point 		4    	//[0 to 255] The black point is the new black - literally. Everything darker than this will become completely black. Default is 16.0
#define Levels_white_point 		255   	//[0 to 255] The new white point. Everything brighter than this becomes completely white. Default is 235.0

//DPX
#define DPXRed   			8.0  	//[1.0 to 15.0] Amount of DPX applies on Red color channel
#define DPXGreen 			8.0  	//[1.0 to 15.0] ""
#define DPXBlue  			8.0  	//[1.0 to 15.0] ""
#define DPXColorGamma    		2.3  	//[0.1 to 2.5] Adjusts the colorfulness of the effect in a manner similar to Vibrance. 1.0 is neutral.
#define DPXSaturation 			5.5  	//[0.0 to 8.0] Adjust saturation of the effect. 1.0 is neutral.
#define DPXRedC   			0.30 	//[0.60 to 0.20] 
#define DPXGreenC 			0.32 	//[0.60 to 0.20]
#define DPXBlueC  			0.00 	//[0.60 to 0.20]
#define DPXBlend 			0.0052  	//[0.00 to 1.00] How strong the effect should be.


//LIFTGAMMAGAIN
#define RGB_Lift  		float3(1.026, 1.044, 1.018)  //[0.000 to 2.000] Adjust shadows for Red, Green and Blue.
#define RGB_Gain  		float3(0.999, 1.009, 1.062)  //[0.000 to 2.000] Adjust highlights for Red, Green and Blue
#define RGB_Gamma 		float3(0.985, 0.985, 0.995)  //[0.000 to 2.000] Adjust midtones for Red, Green and Blue

//TONEMAP
#define Gamma       			1.000  	//[0.000 to 2.000] Adjust midtones. 1.000 is neutral. This setting does exactly the same as the one in Lift Gamma Gain, only with less control.
#define Exposure    			0.020  	//[-1.000 to 1.000] Adjust exposure
#define Saturation  			-0.180  	//[-1.000 to 1.000] Adjust saturation
#define Bleach      			0.000  	//[0.000 to 1.000] Brightens the shadows and fades the colors
#define Defog       			0.600  	//[0.000 to 1.000] How much of the color tint to remove
#define FogColor 			float3(-0.001, 0.00, 0.0082155) //[0.00 to 2.55, 0.00 to 2.55, 0.00 to 2.55] What color to remove - default is blue

//VIBRANCE
#define Vibrance     			0.27  	//[-1.00 to 1.00] Intelligently saturates (or desaturates if you use negative values) the pixels depending on their original saturation.
#define Vibrance_RGB_balance 		float3(0.40, 0.50, 0.50) //[-10.00 to 10.00,-10.00 to 10.00,-10.00 to 10.00] A per channel multiplier to the Vibrance strength so you can give more boost to certain colors over others

//CURVES
#define Curves_mode        		0 	//[0|1|2] Choose what to apply contrast to. 0 = Luma, 1 = Chroma, 2 = both Luma and Chroma. Default is 0 (Luma)
#define Curves_contrast 		0.26 	//[-1.00 to 1.00] The amount of contrast you want

// -- Advanced curve settings --
#define Curves_formula     		1 	//[1|2|3|4|5|6|7|8|9|10] The contrast s-curve you want to use.
                             			//1 = Sine, 2 = Abs split, 3 = Smoothstep, 4 = Exp formula, 5 = Simplified Catmull-Rom (0,0,1,1), 6 = Perlins Smootherstep
                             			//7 = Abs add, 8 = Techicolor Cinestyle, 9 = Parabola, 10 = Half-circles.
                             			//Note that Technicolor Cinestyle is practically identical to Sine, but runs slower. In fact I think the difference might only be due to rounding errors.
                             			//I prefer 2 myself, but 3 is a nice alternative with a little more effect (but harsher on the highlight and shadows) and it's the fastest formula.
		

/*==============================================================================*\
|                           EFFECT PARAMETERS - LIGHTING                         |
\*==============================================================================*/

//BLOOM
#define iBloomMixmode			2	//[1 to 4] 1: Linear add | 2: Screen add | 3: Screen/Lighten/Opacity | 4: Lighten
#define fBloomThreshold			0.75	//[0.1 to 1.0] Every pixel brighter than this value triggers bloom.
#define fBloomAmount			0.25	//[1.0 to 20.0] Intensity of bloom.
#define fBloomSaturation 		0.8	//[0.0 to 2.0] Bloom saturation. 0.0 means white bloom, 2.0 means very very colorful bloom.
#define fBloomTint 		float3(0.610,0.630,0.640) //[0.0 to 1.0] R, G and B components of bloom tintcolor the bloom color gets shifted to.


/*==============================================================================*\
|                      EFFECT PARAMETERS - IMAGE ENHANCEMENTS                    |
\*==============================================================================*/

//SHARPEN
#define fSharpBias  	     		0.7	//[0.05 to 1.0] How big the sharpen offset is (used to compare neighbor pixels to get sharpen amount
#define fSharpStrength 			0.22	//[0.05 to 1.0] Amount of sharpening you want.
#define fSharpClamp 			0.040	//[0.2 to 2.0] Clamps the sharpening to a maximum amount to prevent aliasing

//SMAA
#define fSMAAThreshold			0.12	//[0.05 to 0.20] Edge detection Threshold. If SMAA misses some edges try lowering this slightly. I prefer between 0.08 and 0.12.
#define iSMAAMaxSearchSteps		90	//[0 to 98] Determines the radius SMAA will search for aliased edges
#define iSMAAMaxSearchStepsDiag		16	//[0 to 32] Determines the radius SMAA will search for diagonal aliased edges
#define iSMAACornerRounding		25	//[0 to 100] Determines the percent of antialiasing to apply to corners. 0 seems to affect fine text the least so it's the default.
#define iSMAAEdgeDetectionMode		2	//[1 to 3] 1: Luma edge detection 2: Color edge detection 3: Depth edge detection
#define bSMAAPredication		0	//[0 or 1] Enables predication which uses BOTH the color and the depth texture for edge detection to more accurately detect edges.
#define fSMAAPredicationThreshold	0.09	//[0.001 to 0.2] Threshold to be used in the depth buffer.                                      
#define fSMAAPredicationScale		1.0	//[0.5 to 4.0] How much to scale the global Threshold used for luma or color edge detection when using predication
#define fSMAAPredicationStrength	20.4	//[0.1 to 1.0] How much to locally decrease the Threshold.
#define iSMAADebugOutput		0	//[0 to 4] 0: Normal | 1: edgesTex | 2: blendTex | 3: areaTex | 4: searchTex - Only for troubleshooting. Users don't need to mess with this.

/*==============================================================================*\
|                           EFFECT PARAMETERS - OVERLAYS                         |
\*==============================================================================*/

//END
#define DISABLESPLASH			1	//[0 or 1] Disables the "MasterEffect" splash screen everytime